#! /usr/bin/env python
'''Start the program. Load segments of the program that need to be
started and run them.
'''
import atexit, time, webbrowser, sys

from libs import config, events, friends, globals, logs
from libs import storage, threadmanager
from libs.morado import morado
import tunnels
import uis.web.manager

def start():
    morado.start()
    friends.load_friends()
    storage.manager.start()
    for tunnel in tunnels.registered:
        tunnels.registered[tunnel].start()

    uis.web.manager.start()
    atexit.register(cleanup)

def cleanup():
    events.broadcast('got_shutdown')
    threadmanager.killall()
    threadmanager.close_sockets()
    friends.save_friends()
    config.save()

def main():
    print globals['anon+']['banner'] % (globals['anon+']['VERSION'],
        globals['anon+']['BUILD'])
    print("== Warning! ==")
    print("This is an insecure beta!")
    print
    print("This software has various known weaknesses.")
    print("Please, do not depend on it to be secure!")
    print("Thank you, ~~Devs")
    print

    if '--help' in sys.argv or '-h' in sys.argv:
        print('Usage: vomun [options]')
        print
        print('  -h, --help          Show this help')
        print('      --no-browser    Do not start a browser')
        print('  -v                  Verbose output')
        print('  -V                  Show version')
    if '-V' in sys.argv:
        print('Anonplus %s; build-%s' % (globals['anon+']['VERSION'],
                                         globals['anon+']['BUILD']))
    start()
    if '--no-browser' not in sys.argv:
        webbrowser.open('http://localhost:7777/')
    threadmanager.joinall()

if __name__ == '__main__':
    main()
